<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output indent="yes" method="xml" version="1.0"/>
  <xsl:param name="msi2dbNode">
    <DATABASE NAME="DB_TYPE_NEWDB_2" VERSION="">
      <xsl:comment>JethroData</xsl:comment>
      <MSI DBTYPE="" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeReserved"/>
      <MSI DBTYPE="INTEGER" MAXPRECISION="1" NEXTTYPE="NO_OF_DSS_TYPE" TYPE="DssDataTypeInteger"/>
      <MSI DBTYPE="INTEGER" MAXPRECISION="1" NEXTTYPE="NO_OF_DSS_TYPE+3" TYPE="DssDataTypeUnsigned"/>
      <MSI DBTYPE="DOUBLE" MAXPRECISION="38" NEXTTYPE="DssDataTypeDouble" TYPE="DssDataTypeNumeric"/>
      <MSI DBTYPE="DOUBLE" MAXPRECISION="38" NEXTTYPE="DssDataTypeDouble" TYPE="DssDataTypeDecimal"/>
      <MSI DBTYPE="FLOAT" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeReal"/>
      <MSI DBTYPE="DOUBLE" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeDouble"/>
      <MSI DBTYPE="FLOAT" MAXPRECISION="53" NEXTTYPE="DssDataTypeDouble" TYPE="DssDataTypeFloat"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DssDataTypeLongVarChar" TYPE="DssDataTypeChar"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DssDataTypeLongVarChar" TYPE="DssDataTypeVarChar"/>
      <MSI DBTYPE="STRING" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeLongVarChar"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DssDataTypeLongVarBin" TYPE="DssDataTypeBinary"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DssDataTypeLongVarBin" TYPE="DssDataTypeVarBin"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeLongVarBin"/>
      <MSI DBTYPE="TIMESTAMP" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeDate"/>
      <MSI DBTYPE="TIMESTAMP" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeTime"/>
      <MSI DBTYPE="TIMESTAMP" MAXPRECISION="DDT_NO_MAXPRECISION" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeTimeStamp"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeNChar"/>
      <MSI DBTYPE="STRING" MAXPRECISION="255" NEXTTYPE="DDT_NULL_NEXTTYPE" TYPE="DssDataTypeNVarChar"/>
      <MSI DBTYPE="INTEGER" MAXPRECISION="1" NEXTTYPE="NO_OF_DSS_TYPE+1" TYPE="DssDataTypeInteger"/>
      <MSI DBTYPE="INTEGER" MAXPRECISION="1" NEXTTYPE="NO_OF_DSS_TYPE+2" TYPE="DssDataTypeInteger"/>
      <MSI DBTYPE="BIGINT" MAXPRECISION="1" NEXTTYPE="DssDataTypeDouble" TYPE="DssDataTypeInteger"/>
      <MSI DBTYPE="INTEGER" MAXPRECISION="1" NEXTTYPE="NO_OF_DSS_TYPE+4" TYPE="DssDataTypeUnsigned"/>
      <MSI DBTYPE="INTEGER" MAXPRECISION="1" NEXTTYPE="NO_OF_DSS_TYPE+5" TYPE="DssDataTypeUnsigned"/>
      <MSI DBTYPE="BIGINT" MAXPRECISION="1" NEXTTYPE="DssDataTypeDouble" TYPE="DssDataTypeUnsigned"/>
    </DATABASE>
  </xsl:param>
  <xsl:param name="db2msiNode">
    <DATABASE MDTYPE="MD_ODBC" NAME="DB_TYPE_NEWDB_2" VERSION="">
      <xsl:comment>JethroData</xsl:comment>
      <CATALOG MSITYPE="DssDataTypeReserved" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_UNKNOWN_TYPE"/>
      <CATALOG MSITYPE="DssDataTypeChar" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_CHAR"/>
      <CATALOG MSITYPE="DssDataTypeNumeric" PRECISION="15" PRECISION_SCALE="PRECISION_SCALE" SCALE="4" TYPE="SQL_NUMERIC"/>
      <CATALOG MSITYPE="DssDataTypeDecimal" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="PRECISION_SCALE" SCALE="DDT_NULL_SCALE" TYPE="SQL_DECIMAL"/>
      <CATALOG MSITYPE="DssDataTypeInteger" PRECISION="4" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_INTEGER"/>
      <CATALOG MSITYPE="DssDataTypeInteger" PRECISION="2" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_SMALLINT"/>
      <CATALOG MSITYPE="DssDataTypeReal" PRECISION="53" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_FLOAT"/>
      <CATALOG MSITYPE="DssDataTypeReal" PRECISION="53" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_REAL"/>
      <CATALOG MSITYPE="DssDataTypeDouble" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_DOUBLE"/>
      <CATALOG MSITYPE="DssDataTypeDate" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_DATE"/>
      <CATALOG MSITYPE="DssDataTypeTime" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="SCALE" SCALE="DDT_NULL_SCALE" TYPE="SQL_TIME"/>
      <CATALOG MSITYPE="DssDataTypeTimeStamp" PRECISION="9" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_TIMESTAMP"/>
      <CATALOG MSITYPE="DssDataTypeDate" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_TYPE_DATE"/>
      <CATALOG MSITYPE="DssDataTypeTime" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="SCALE" SCALE="DDT_NULL_SCALE" TYPE="SQL_TYPE_TIME"/>
      <CATALOG MSITYPE="DssDataTypeTimeStamp" PRECISION="9" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_TYPE_TIMESTAMP"/>
      <CATALOG MSITYPE="DssDataTypeVarChar" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_VARCHAR"/>
      <CATALOG MSITYPE="DssDataTypeLongVarChar" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_LONGVARCHAR"/>
      <CATALOG MSITYPE="DssDataTypeBinary" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_BINARY"/>
      <CATALOG MSITYPE="DssDataTypeBinary" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="NONE" SCALE="DDT_NULL_SCALE" TYPE="SQL_VARBINARY"/>
      <CATALOG MSITYPE="DssDataTypeLongVarBin" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_LONGVARBINARY"/>
      <CATALOG MSITYPE="DssDataTypeInt64" PRECISION="8" PRECISION_SCALE="LENGTH" SCALE="0" TYPE="SQL_BIGINT"/>
      <CATALOG MSITYPE="DssDataTypeInteger" PRECISION="1" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_TINYINT"/>
      <CATALOG MSITYPE="DssDataTypeVarChar" PRECISION="1" PRECISION_SCALE="LENGTH" SCALE="DDT_NULL_SCALE" TYPE="SQL_BIT"/>
      <CATALOG MSITYPE="DssDataTypeNChar" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="PRECISION" SCALE="DDT_NULL_SCALE" TYPE="SQL_WCHAR"/>
      <CATALOG MSITYPE="DssDataTypeNVarChar" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="PRECISION" SCALE="DDT_NULL_SCALE" TYPE="SQL_WVARCHAR"/>
      <CATALOG MSITYPE="DssDataTypeLongVarChar" PRECISION="DDT_NULL_PRECISION" PRECISION_SCALE="PRECISION" SCALE="DDT_NULL_SCALE" TYPE="SQL_WLONGVARCHAR"/>
    </DATABASE>
  </xsl:param>
  <xsl:template match="/ | @* | node()" name="identity">
    <xsl:copy>
      <xsl:apply-templates select="@* | node()"/>
    </xsl:copy>
  </xsl:template>
  <xsl:template match="/MSI_DATATYPE_MAPPING/MSI_TO_DB/DATABASE[@NAME='DB_TYPE_NEWDB_2' and @VERSION='']"/>
  <xsl:template match="/MSI_DATATYPE_MAPPING/CATALOG_TO_MSI/DATABASE[@NAME='DB_TYPE_NEWDB_2' and @VERSION='']"/>
  <xsl:template match="/MSI_DATATYPE_MAPPING/MSI_TO_DB/DATABASE[position()=last()]">
    <xsl:call-template name="identity"/>
    <xsl:copy-of select="$msi2dbNode"/>
  </xsl:template>
  <xsl:template match="/MSI_DATATYPE_MAPPING/CATALOG_TO_MSI/DATABASE[position()=last()]">
    <xsl:call-template name="identity"/>
    <xsl:copy-of select="$db2msiNode"/>
  </xsl:template>
</xsl:stylesheet>
